package dk.miracleas.dis.transformer;

import java.io.StringReader;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.stream.StreamSource;

import org.switchyard.annotations.Transformer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import dk.miracleas.dis.model.DualDao;
import dk.miracleas.dis.model.DualReply;

public final class Transformers {

	@Transformer(to = "{urn:dk.miracleas:DualInterfaceService:0.0.1-SNAPSHOT}handleResponse")
	public Element transformDualReplyToHandleResponse(DualReply from) {
		return toElement("<fisk>helleflynder</fisk>");
	}

	@Transformer(from = "{urn:dk.miracleas:DualInterfaceService:0.0.1-SNAPSHOT}handle")
	public DualDao transformHandleToDualDao(Element element) {
		return new DualDao().setId(getElementValue(element, "id")).setName(getElementValue(element, "name"));
	}
	
	private String getElementValue(Element parent, String elementName) {
		String value = null;
		NodeList nodes = parent.getElementsByTagName(elementName);
		if (nodes.getLength() > 0) {
			value = nodes.item(0).getChildNodes().item(0).getNodeValue();
		}
		return value;
	}
	
	private Element toElement(String xml) {
		DOMResult dom = new DOMResult();
		try {
			TransformerFactory.newInstance().newTransformer().transform(new StreamSource(new StringReader(xml)), dom);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return ((Document)dom.getNode()).getDocumentElement();
	}
}
